<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical
      el-form.flex-form(
      ref='categoriesForm'
      v-if="inputs.length"
      :model='stateForm'
      :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
          :prop="item.name")
          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :required="item.required"
            :maxlength="item.maxlength"
            @input-value="modelValue")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='newsActive'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/categories'}")
        |Отмена

      el-button.button(
      type="success"
      @click="createNews('categoriesForm')")
        |Создать категорию

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'CategoriesItem',
  components: {
    'app-input': InputItem
  },
  data() {
    return {
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите название категории',
          model: '',
          label: 'Название категории',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false,
      newsActive: true
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Категории товаров',
        slug: '/admin/categories'
      }
    ]);
    this.$store.commit('headingTitle', 'Cоздание категории');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', '');
  },
  methods: {
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.inputs[index].model = valueArr[1];
    },
    createNews(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .post('/api/v1/categories/', {
              name: this.stateForm.name,
              sort: this.stateForm.sort,
              active: this.newsActive
            })
            .then(
              () => {
                this.pageLoading = false;
                this.$router.push('/admin/categories');
                this.$message.success('Категория успешно добавлена!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
